import { Observable } from 'rxjs/Observable';
import { ActiveDescendantKeyManager } from '@angular/cdk/a11y';
import { CdkOverlayOrigin } from '@angular/cdk/overlay';
import { AfterContentInit, ChangeDetectorRef, ElementRef, EventEmitter, NgZone, OnDestroy, QueryList } from '@angular/core';
import { ControlValueAccessor, NgControl } from '@angular/forms';
import { NtOptionComponent, NtOptionParentComponent, NtOptionSelectionChange, NtOverlayComponent } from '@ng-tangram/components/core';
import { NtFormFieldControl } from '@ng-tangram/components/forms';
export declare function getNtSelectDynamicMultipleError(): Error;
export declare function getNtSelectNonArrayValueError(): Error;
export declare function getNtSelectNonFunctionValueError(): Error;
export declare class NtSelectChange {
    source: NtSelectComponent;
    value: any;
    constructor(source: NtSelectComponent, value: any);
}
export declare class NtSelectComponent extends NtFormFieldControl<any> implements AfterContentInit, ControlValueAccessor, NtOptionParentComponent, OnDestroy {
    private _ngZone;
    private _elementRef;
    private _changeDetectorRef;
    ngControl: NgControl;
    private readonly _destroy;
    readonly origin: CdkOverlayOrigin;
    private _disabled;
    private _focused;
    private _selectionModel;
    private _state;
    private _placeholder;
    private _width;
    private _multiple;
    private _value;
    private _required;
    private _compareWith;
    private _onChange;
    private _onTouched;
    private _filter;
    readonly value: any;
    readonly triggerValue: string;
    readonly empty: boolean;
    readonly optionEmpty: boolean;
    readonly focused: boolean;
    disabled: boolean;
    required: boolean;
    readonly state: string;
    readonly width: number;
    multiple: boolean;
    filter: (input: string, option: NtOptionComponent) => boolean;
    filterNotFound: string;
    readonly selected: NtOptionComponent | NtOptionComponent[];
    placeholder: string;
    _keyManager: ActiveDescendantKeyManager<NtOptionComponent>;
    inputElement: ElementRef;
    paneElement: ElementRef;
    overlay: NtOverlayComponent;
    options: QueryList<NtOptionComponent>;
    readonly selectionChange: EventEmitter<NtSelectChange>;
    readonly valueChange: EventEmitter<any>;
    compareWith: (o1: any, o2: any) => boolean;
    readonly optionSelectionChanges: Observable<NtOptionSelectionChange>;
    constructor(_ngZone: NgZone, _elementRef: ElementRef, _changeDetectorRef: ChangeDetectorRef, ngControl: NgControl);
    ngOnInit(): void;
    ngAfterContentInit(): void;
    onResize(): void;
    onSearch(event: KeyboardEvent): void;
    onBeforeOpen(): void;
    onBeforeClosed(): void;
    onAfterClosed(): void;
    onFocus(): void;
    onBlur(): void;
    focus(): void;
    writeValue(value: any): void;
    registerOnChange(fn: (_: any) => {}): void;
    registerOnTouched(fn: () => {}): void;
    clear(): void;
    setDisabledState(isDisabled: boolean): void;
    /** Handles all keydown events on the select. */
    _handleKeydown(event: KeyboardEvent): void;
    /** Handles keyboard events when the selected is open. */
    private _handleOpenKeydown(event);
    private _handleClosedKeydown(event);
    private _resetOptions();
    /** Sets up a key manager to listen to keyboard events on the overlay panel. */
    private _initKeyManager();
    private _resetFilterResult();
    private _initializeSelection();
    private _setSelectionByValue(value, isUserInput?);
    private _selectValue(value, isUserInput?);
    private _propagateChanges(fallbackValue?);
    private _clearSelection(skip?);
    private _sortValues();
    private _onSelect(option);
    /**
     * Highlights the selected item. If no option is selected, it will highlight
     * the first item instead.
     */
    private _highlightCorrectOption();
    private _scrollActiveOptionIntoView();
    ngOnDestroy(): void;
}
